/*
  RabidVWM LiteStep Module - version 1.0
	IDropTarget Interface

  Copyright (C) 2002 Joshua Seagoe
 
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef INC_DROPTARGET_H_1
#define INC_DROPTARGET_H_1

#define atoi not_atoi
#include "oleidl.h"
#undef atoi

class SkinBoxDropTarget : public IDropTarget
{
public:
//		Required interface.
	HRESULT STDMETHODCALLTYPE QueryInterface( 
		/* [in] */ REFIID riid,
		/* [iid_is][out] */ void __RPC_FAR *__RPC_FAR *ppvObject);

	ULONG STDMETHODCALLTYPE AddRef( void);

	ULONG STDMETHODCALLTYPE Release( void);

	HRESULT STDMETHODCALLTYPE DragEnter( 
		/* [unique][in] */ IDataObject *pDataObj,
		/* [in] */ DWORD grfKeyState,
		/* [in] */ POINTL pt,
		/* [out][in] */ DWORD *pdwEffect);

	HRESULT STDMETHODCALLTYPE DragOver( 
		/* [in] */ DWORD grfKeyState,
		/* [in] */ POINTL pt,
		/* [out][in] */ DWORD *pdwEffect);

	HRESULT STDMETHODCALLTYPE DragLeave( void);

	HRESULT STDMETHODCALLTYPE Drop( 
		/* [unique][in] */ IDataObject *pDataObj,
		/* [in] */ DWORD grfKeyState,
		/* [in] */ POINTL pt,
		/* [out][in] */ DWORD *pdwEffect);


//		Locally used stuff.

	inline HRESULT Register(WndInfo *);
	inline HRESULT Revoke(void);

	static void RegisterFormats(void);

protected:
	typedef void (SkinBoxDropTarget::*DropFuncPtr)(void *);

  WndInfo *pWnd;

	int cf_index;
	static UINT cf_types[8];
	static DropFuncPtr cf_actions[8];

	void Drop_HDROP(void *);
	void Drop_SHELLIDLIST(void *);
	void Drop_INETURL(void *);
	void Drop_SHELLURL(void *);
	void Drop_TEXT(void *);
	void Drop_UNICODETEXT(void *);

  bool CheckDropType(FORMATETC &etc, IDataObject *pDataObj);
};

HRESULT SkinBoxDropTarget::Register(WndInfo *w)
{
  pWnd = w;
  cf_index = -1;
  return RegisterDragDrop(pWnd->hWnd, this);
}

HRESULT SkinBoxDropTarget::Revoke(void)
{
  return RevokeDragDrop(pWnd->hWnd);
}

#endif