//#undef NDEBUG

#define WIN32_LEAN_AND_MEAN
#include <windows.h>

/*
#ifndef NDEBUG
void Trace(LPSTR msg1,LPSTR msg2);
void AssertFail(LPSTR,LPSTR,LPSTR,int,int,DWORD*);
#define TRACE(level,message) Trace(const_cast<LPSTR>(message),"");
#define TRACE2(level,msg1,msg2) Trace(const_cast<LPSTR>(msg1),const_cast<LPSTR>(msg2));
#define ASSERT(n) if(!(n))AssertFail("ASSERT",#n,__FILE__,__LINE__,-1,NULL)
#define TASSERT(n,c,t) if(!(n))AssertFail("ASSERT",#n,__FILE__,__LINE__,(c),(t))
#define ASSERTV(n) if(!(n))AssertFail("ASSERTV",#n,__FILE__,__LINE__,-1,NULL)
#define ASSERT_READABLE(n) if(!READABLE((n),sizeof(*(n))))AssertFail("ASSERT_READABLE",#n,__FILE__,__LINE__,0,(DWORD*)(n))
#define ASSERT_WRITEABLE(n) if(!WRITEABLE((n),sizeof(*(n)))) AssertFail("ASSERT_WRITEABLE",#n,__FILE__,__LINE__,0,(DWORD*)(n))
#define ASSERT_READABLEC(n,c) if(!READABLE((n),(c)))AssertFail("ASSERT_READABLEC",#n,__FILE__,__LINE__,0,(DWORD*)(n))
#define ASSERT_WRITEABLEC(n,c) if(!WRITEABLE((n),(c)))AssertFail("ASSERT_WRITEABLEC",#n,__FILE__,__LINE__,0,(DWORD*)(n))
#define ASSERT_EXECABLE(n) if(!EXECABLE((n)))AssertFail("ASSERT_EXECABLE",#n,__FILE__,__LINE__,0,(DWORD*)(n))
#else
#define TRACE(level,message) (void)0
#define TRACE2(level,msg1,msg2) (void)0
#define ASSERT(n) (void)0
#define TASSERT(n,c,t) (void)0
#define ASSERTV(n) __assume(n)
#define ASSERT_READABLE(n) __assume(n!=NULL)
#define ASSERT_WRITEABLE(n) __assume(n!=NULL)
#define ASSERT_READABLEC(n,c) __assume(n!=NULL)
#define ASSERT_WRITEABLEC(n,c) __assume(n!=NULL)
#define ASSERT_EXECABLE(n) __assume(n!=NULL)
#endif

#define LSAssertFail YourMama
*/

//#define NOLSLOG
#include <ls-b247\lsapi\lsapi.h>
#include "lsb_contract.h"
#define ASSERT_READABLE(n) ASSERT_PTR(n, READABLE(n))
#define ASSERT_WRITEABLE(n) ASSERT_PTR(n, WRITEABLE(n))
#define ASSERT_EXECABLE(n) ASSERT_PTR(n, EXECABLE(n))
#define ASSERT_READABLEC(n,c) ASSERT_PTR(n, READABLEN(n,c))
#define ASSERT_WRITEABLEC(n,c) ASSERT_PTR(n, WRITEABLEN(n,c))
#define ASSERT_EXECABLEC(n,c) ASSERT_PTR(n, EXECABLEN(n,c))
#include "multimonitor.h"
#include "lsmod_common.h"
//#include "lstoolsemu.h"
//#include "..\AggressiveOptimize.h"

#ifdef LS_AUTHORIZATION_UNAVAILABLE
#error Wrong LSAPI.H.  Make sure the path is right.
#endif

#include "settings.h"

extern const char * const ModuleName;
extern const char * const ModuleVersion;
extern const char * const ModuleAuthor;
extern const char * const ModuleBuild;

#define MODULE ModuleName

extern const char ModuleBangPrefix[];
extern const int ModuleBangPrefixLen;
extern const char ModuleRCPrefix[];
extern const int ModuleRCPrefixLen;
#ifndef SINGLE_WINDOW
extern const char ModuleListKey[];
extern const int ModuleListKeyLen;
#endif

#ifndef NO_SCRIPT_ACTIONS
class SkinBoxDropTarget;
#include "atvar2.h"
#endif

struct lsBangCmdDef
{
  const char *Name;
  BangCommand *Command;
};

extern lsBangCmdDef Bangs[];

extern
BOOL  (WINAPI *dAlphaBlend)( IN HDC, IN int, IN int, IN int, IN int,
    IN HDC, IN int, IN int, IN int, IN int, IN BLENDFUNCTION);
extern
BOOL (WINAPI *dUpdateLayeredWindow)(HWND,HDC,POINT*,SIZE*,HDC,POINT*,
		COLORREF,BLENDFUNCTION*,DWORD);

#ifndef WS_EX_LAYERED
#define WS_EX_LAYERED           0x00080000
#define ULW_COLORKEY            0x00000001
#define ULW_ALPHA               0x00000002
#define ULW_OPAQUE              0x00000004
#endif

#define UGWL_WNDINFO_PTR 0

struct Config;
struct ConfigItemType;
struct ConfigItem
{
  const char *Key;
  int KeyLen; /* number of chars after Key to insert any subkeys */ 
  int iOffset; /* MEMBER_OFFSET */ 
  bool bOptional;
  ConfigItemType *Type;
  LPARAM lParam1; /* usually default value */ 
  LPARAM lParam2; /* usually max value */ 
};


#ifndef NO_SCRIPT_ACTIONS
enum ScriptActionTypes
{
  /* must be same order as ScriptActionStrings */ 
  /* valid for windows and module */ 
  OnCreate, OnDestroy,
  OnMouseOver, OnMouseOut,
  OnMouseMove, OnHover, OnUnhover,
  OnLButtonDown, OnLButtonUp, OnLButtonClick,
  OnRButtonDown, OnRButtonUp, OnRButtonClick,
  OnMButtonDown, OnMButtonUp, OnMButtonClick,
  OnDropFile, OnDropText, OnDropURL,
  ScriptActionWindowCount,

  /* valid for module only        */ 
  OnInit = ScriptActionWindowCount,
  OnQuit,
  ScriptActionModuleCount,
};
typedef char *ScriptAction;
typedef ScriptAction *ScriptActionSet;
struct s_ScriptActionName { const char *Name; int Length; };
extern s_ScriptActionName ScriptActionStrings[ScriptActionModuleCount+1];
extern rcVarLookupProc ScriptActionDefaults[ScriptActionModuleCount];
#endif

enum TimerEvents
{
  NotAnEvent = 100,
  HoverTimerEvent
};

struct s_Ordinate
{
  int Value;
  int BasePercent;
  int Offset;
};

struct s_Position
{
  static const ConfigItem * const ConfigItemPtr;

  char *MonitorName;
  LSMONITOR Monitor;
  s_Ordinate X,Y,Width,Height;
};

struct s_Color
{
  /* these are not really valid COLORREFs,    */ 
  /* since the high byte may not be 0 (alpha) */ 
  COLORREF Simple;
#define COLOR_NOSYSCOLOR -2
#define COLOR_SELFFACE -1
  int SysColor;
#define COLOR_SCALELIGHT 40
#define COLOR_SCALESHADOW -40
#define COLOR_SCALEDKSHADOW -120
#define COLOR_SCALEOUTERLIGHT 0
  int Scale;
  COLORREF Value;
};

struct s_EdgeColors
{
  static const ConfigItem * const ConfigItemPtr;
  static const char * const StyleEnum[];
  enum { FlatStyle, RaisedStyle, SunkenStyle,
    RidgeStyle, GrooveStyle, RaisedButtonStyle, SunkenButtonStyle };
  enum { LightEdge, DarkEdge, BrLightEdge, DkDarkEdge };

  s_Color Face;
  s_Color Edge[4];
  int Style;
};

struct lsEdgeMap {
	HBITMAP Bitmap;
	SIZE Size;
	RECT Edge;
	bool Tile, HasAlpha;
};

struct WndInfo
{
  static const ConfigItem * const ConfigItemPtr;

#ifndef SINGLE_WINDOW
  WndInfo *pNext; /* must be first element */ 

  char *Name;
  int Group; /* 0 = no group */ 
#endif

	HWND hWnd;
	HWND hParentWnd;

  s_Position Pos;
  SIZE szParent;

	LONG Alpha;

	bool bTrueAlpha;
	bool bOnTop;
	bool bHidden;

	HBITMAP hbmBackBuffer;

#ifndef NO_SKIN
  lsEdgeMap emSkin;
  s_EdgeColors cSkin;
#endif

#ifndef NO_SCRIPT_ACTIONS
  UINT_PTR HoverTimerID;
  POINT HoverPoint;
  bool bHovering;
  bool bMouseOver;
  bool bLButtonDown;
  bool bMButtonDown;
  bool bRButtonDown;
#endif

#if !defined(NO_SCRIPT_ACTIONS) && !defined(SINGLE_WINDOW)
  /* each window can have its own actions  */ 
  /* if it does, the module one is ignored */ 
  /* length = ScriptActionWindowCount      */ 
  ScriptActionSet Actions;

  SkinBoxDropTarget *DropTarget;
  const char *DropItem;
  int nDropLeft;

  LONG HoverTime; /* 0 = use global hover time */ 
#endif
};

/* Global data for the module.   */ 
/* Grouped together partially so */ 
/* we can clear it all at once.  */ 
struct ModInfo
{
  static const ConfigItem * const ConfigItemPtr;

	HWND hBottomParentWnd;
	HINSTANCE hInstance;

#ifdef SINGLE_WINDOW
	bool bWaitForBox;
  WndInfo MainWnd;
#else
  WndInfo *pWnds;
#endif

#ifndef NO_SCRIPT_ACTIONS
  /* global module-wide actions       */ 
  /* length = ScriptActionModuleCount */ 
  ScriptActionSet Actions;

  LONG HoverTime;
#endif
};

extern const ConfigItem * const          RECT_ConfigItemPtr;
extern const ConfigItem * const       WndShow_ConfigItemPtr;
extern const ConfigItem * const          Size_ConfigItemPtr;
extern const ConfigItem * const WndOnTop_ConfigItemPtr;
extern const ConfigItem * const SkinTile_ConfigItemPtr;
extern const ConfigItem * const Alpha_ConfigItemPtr;


extern ModInfo Module; /* global module data */ 

// create a window and mark it as part of litestep
bool CreateWnd(WndInfo *w);
// update size and position of window
void UpdateWndPos(WndInfo *w);
// update on top/bottem setting
void UpdateWndOnTop(WndInfo *w);
// update hide/show
void UpdateWndHidden(WndInfo *w);

// paint the window
void PaintWnd(WndInfo *w,HDC hdc);
void RedrawWnd(WndInfo *w);

#ifndef NO_SCRIPT_ACTIONS
/*
// this needs to go into lstools
void ReplaceAtVars(char *dest,int maxchars,const char *src,
                   int (*LookupVar)(char *dest,int maxchars,const char *src,LPARAM lParam),
                   LPARAM lParam);
*/

// execute an action by string, in a given window's context
//void ExecActionString(HWND hCaller,WndInfo *w,const char *sAction);
void ExecActionString(HWND hCaller, WndInfo *w, const char *sAction, rcVarLookupProc defproc);
// execute an action by index (checks range for window actions *only*)
void ExecAction(WndInfo *w,int iAction);
// set or clear an action on a window or on the module
bool SetAction(WndInfo *w,int iAction,const char *Command);
// set or clear an action in a set (does not check range)
bool SetAction(ScriptActionSet *pas,int nActions,int iAction,const char *Command);

#ifndef SINGLE_WINDOW
inline int GetHoverTime(WndInfo *w) { return w->HoverTime?w->HoverTime:Module.HoverTime; }
#else /* SINGLE_WINDOW */ 
inline int GetHoverTime(WndInfo *) { return Module.HoverTime; }
#endif /* SINGLE_WINDOW */ 

inline bool IsKeyDown(int key) { return (GetKeyState(key)&0x8000)!=0; }

#endif /* NO_SCRIPT_ACTIONS */ 

#ifndef SINGLE_WINDOW
// create all of the windows
void CreateWindows(void);
// read a windows config
bool ParseBoxProc(void *elem,const char *line,DWORD conf);
// close and release the windows
void FreeWndProc(void *elem,DWORD);
void AddWindow(WndInfo *w);
#endif


const char *IntParser(int *i,const char *s,bool *b);

inline int atoi(const char *ptr)
{ int i=0; IntParser(&i,ptr,NULL); return i; }

inline bool WndInBox(WndInfo *w)
{ return w->hParentWnd != Module.hBottomParentWnd; }


void CalcOrd(s_Ordinate *o, int min, int max);
// update colors, return true if the value has changed
bool CalcColorSet(s_EdgeColors *ec);


int LSStringEnum(const char *string,const char **list,int inc=sizeof(char*));
void LSRegisterBangList(const char *sPrefix, unsigned nLen, lsBangCmdDef *Bangs);
void LSRemoveBangList(const char *sPrefix, unsigned nLen, lsBangCmdDef *Bangs);

typedef BOOL (*DesktopPainterProc)(HDC hdc);
	LSAPI BOOL LSTileBltAligned(HDC d, int dl, int dt, int dw, int dh,
		HDC s, int sl, int st, int sw, int sh, int x, int y, DWORD rop);
	LSAPI BOOL LSTileBlt(HDC d, int dl, int dt, int dw, int dh,
		HDC s, int sl, int st, int sw, int sh, DWORD rop);
	LSAPI BOOL LSTransEdgeBlt(HDC d, const RECT *rDest, HDC s, lsEdgeMap *emSrc, BOOL bTransBlt);
	LSAPI BOOL LSSetPaintDesktopHook(DesktopPainterProc UserProc);
	LSAPI void LSPaintDesktop(HDC hdcD, int xD, int yD, int cxD, int cyD,
		int xS, int yS, BOOL bUpdateCache=FALSE);
	LSAPI void LSFreeDesktopBmp(void);
